function [N,M] = singleCellwireframe(length,type,origin)

csize.x=length;
csize.y=length;
csize.z=length;

L=length;
% lattice origin

switch(type)
    case('Box')
        nodes=[origin;
            (origin(1)+csize.x),origin(2),origin(3);
            origin(1)+csize.x,origin(2)+csize.y,origin(3);
            origin(1),origin(2)+csize.y,origin(3);
            origin(1),origin(2),origin(3)+csize.z;
            origin(1)+csize.x,origin(2),origin(3)+csize.z;
            origin(1)+csize.x,origin(2)+csize.y,origin(3)+csize.z;
            origin(1),origin(2)+csize.y,origin(3)+csize.z];
     case('BCC')
    
    nodes=[origin;
        (origin(1)+csize.x),origin(2),origin(3);
        origin(1)+csize.x,origin(2)+csize.y,origin(3);
        origin(1),origin(2)+csize.y,origin(3);
        origin(1),origin(2),origin(3)+csize.z;
        origin(1)+csize.x,origin(2),origin(3)+csize.z;
        origin(1)+csize.x,origin(2)+csize.y,origin(3)+csize.z;
        origin(1),origin(2)+csize.y,origin(3)+csize.z;
        origin(1)+csize.x/2,origin(2)+csize.y/2,origin(3)+csize.z/2];
    case('FCC')
    
    nodes=[origin;
        (origin(1)+csize.x),origin(2),origin(3);
        origin(1)+csize.x,origin(2)+csize.y,origin(3);
        origin(1),origin(2)+csize.y,origin(3);
        origin(1),origin(2),origin(3)+csize.z;
        origin(1)+csize.x,origin(2),origin(3)+csize.z;
        origin(1)+csize.x,origin(2)+csize.y,origin(3)+csize.z;
        origin(1),origin(2)+csize.y,origin(3)+csize.z;
        origin(1)+csize.x/2,origin(2)+csize.y/2,origin(3);
        origin(1)+csize.x/2,origin(2)+csize.y/2,origin(3)+csize.z;
        origin(1)+csize.x/2,origin(2),origin(3)+csize.z/2;
        origin(1)+csize.x/2,origin(2)+csize.y,origin(3)+csize.z/2;
        origin(1),origin(2)+csize.y/2,origin(3)+csize.z/2;
        origin(1)+csize.x,origin(2)+csize.y/2,origin(3)+csize.z/2];
    case('Octet')
    
    nodes=[origin;
        (origin(1)+csize.x),origin(2),origin(3);
        origin(1)+csize.x,origin(2)+csize.y,origin(3);
        origin(1),origin(2)+csize.y,origin(3);
        origin(1),origin(2),origin(3)+csize.z;
        origin(1)+csize.x,origin(2),origin(3)+csize.z;
        origin(1)+csize.x,origin(2)+csize.y,origin(3)+csize.z;
        origin(1),origin(2)+csize.y,origin(3)+csize.z;
        origin(1)+csize.x/2,origin(2)+csize.y/2,origin(3);
        origin(1)+csize.x/2,origin(2)+csize.y/2,origin(3)+csize.z;
        origin(1)+csize.x/2,origin(2),origin(3)+csize.z/2;
        origin(1)+csize.x/2,origin(2)+csize.y,origin(3)+csize.z/2;
        origin(1),origin(2)+csize.y/2,origin(3)+csize.z/2;
        origin(1)+csize.x,origin(2)+csize.y/2,origin(3)+csize.z/2];
    
    case('Octahedron')
    
    nodes=[origin(1),origin(2),origin(3)+csize.z/2;
        origin(1)+csize.x,origin(2),origin(3)+csize.z/2;
        origin(1)+csize.x,origin(2)+csize.y,origin(3)+csize.z/2;
        origin(1),origin(2)+csize.y,origin(3)+csize.z/2;
        origin(1)+csize.x/2,origin(2)+csize.y/2,origin(3)+csize.z;
        origin(1)+csize.x/2,origin(2)+csize.y/2,origin(3)];
        
    case('CVC')
    
    nodes=[origin;
        origin(1)+csize.x,origin(2),origin(3);
        origin(1)+csize.x,origin(2)+csize.y,origin(3);
        origin(1),origin(2)+csize.y,origin(3);
        origin(1),origin(2),origin(3)+csize.z;
        origin(1)+csize.x,origin(2),origin(3)+csize.z;
        origin(1)+csize.x,origin(2)+csize.y,origin(3)+csize.z;
        origin(1),origin(2)+csize.y,origin(3)+csize.z;
        origin(1)+csize.x/2,origin(2)+csize.y/2,origin(3)+csize.z/2];
end

% Remove nodal duplicate
[N,~,~]=unique(nodes,'rows','stable');

% Connection line matrix
count=1;
M=[];
misc.ebound=0.000001;
rod_length_lin=csize.x;

switch(type)
    case('Box')
    for n=1:size(N,1) %ciclo for per quanti sono i nodi
        %sprintf('Current loop %d of %d',n,size(N,1))
        for m=1:size(N,1) 
            if 1 % To remove duplicate connections
                % If not checked for m>n (or vice versa) then the element
                % could be created twice for combination (m,n) and (n,m)
                % which would be a useless element.
                 %if N(n,1)-fix(N(n,1))==0.5 || N(m,1)-fix(N(m,1))==0.5
                
                if sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_lin+misc.ebound && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_lin-misc.ebound 
                    % rem(N(n,1),L)==0 && rem(N(n,2),L)==0 && rem(N(n,3),L)==0
                    % if elements are exactly the correct spacing from one node
                    % to the next, then connect with beam/rod.
                    P(count,:)=[n,m];
                    count=count+1;
                    % Join nodes if spacing is exactly cell size
                    if m>n
                        M=[M;n,m];

                    end
                end
            end
        end
    end    
    case('BCC')
    
    rod_length_obl=sqrt((csize.x/2)^2+(csize.y/2)^2+(csize.z/2)^2); % Correct lenght of elements to find spacing
    for n=1:size(N,1) %ciclo for per quanti sono i nodi
        %sprintf('Current loop %d of %d',n,size(N,1))
        for m=1:size(N,1) 
            if 1 % To remove duplicate connections
                % If not checked for m>n (or vice versa) then the element
                % could be created twice for combination (m,n) and (n,m)
                % which would be a useless element.
                 %if N(n,1)-fix(N(n,1))==0.5 || N(m,1)-fix(N(m,1))==0.5
                if sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_obl+misc.ebound && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_obl-misc.ebound
                    % if elements are exactly the correct spacing from one node
                    % to the next, then connect with beam/rod.
                    P(count,:)=[n,m];
                    count=count+1;
                    % Join nodes if spacing is exactly cell size
                    if m>n
                        M=[M;n,m];

                    end
                end

                if sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_lin+misc.ebound && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_lin-misc.ebound &&...
                    rem(N(n,1),L)==0 && rem(N(n,2),L)==0 && rem(N(n,3),L)==0
                    % if elements are exactly the correct spacing from one node
                    % to the next, then connect with beam/rod.
                    P(count,:)=[n,m];
                    count=count+1;
                    % Join nodes if spacing is exactly cell size
                    if m>n
                        M=[M;n,m];

                    end
                end
            end
        end
    end
    
    case('FCC')
        
    rod_length_obl=sqrt((csize.x/2)^2+(csize.y/2)^2); % Correct lenght of elements to find spacing

    for n=1:size(N,1)
            %sprintf('Current loop %d of %d',n,size(N,1))
            for m=1:size(N,1)
                if 1 % To remove duplicate connections
                    % If not checked for m>n (or vice versa) then the element
                    % could be created twice for combination (m,n) and (n,m)
                    % which would be a useless element.

                    switch 1
                        case any(sqrt(sum((N(n,:)-N(m,:)).^2))>(sqrt((csize.x/2)^2+(csize.y/2)^2)-misc.ebound) && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))<(sqrt((csize.x/2)^2+(csize.y/2)^2)+misc.ebound) ) && ...
                        all(abs(N(n,:)-N(m,:))==[csize.x/2,csize.y/2,0]) && ...
                        rem(N(n,3),csize.z)==0
                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                            if m>n
                                M=[M;n,m];

                            end

                        case any(sqrt(sum((N(n,:)-N(m,:)).^2))<(sqrt((csize.x/2)^2+(csize.z/2)^2)+misc.ebound) && ...
                            sqrt(sum((N(n,:)-N(m,:)).^2))>(sqrt((csize.x/2)^2+(csize.z/2)^2)-misc.ebound)) && ...
                            all(abs(N(n,:)-N(m,:))==[csize.x/2,0,csize.z/2]) && ...
                        rem(N(n,2),csize.y)==0

                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                            if m>n
                                M=[M;n,m];

                            end
                        case any(sqrt(sum((N(n,:)-N(m,:)).^2))<(sqrt((csize.z/2)^2+(csize.y/2)^2)+misc.ebound) && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))>(sqrt((csize.z/2)^2+(csize.y/2)^2)-misc.ebound)) && ...
                        all(abs(N(n,:)-N(m,:))==[0,csize.y/2,csize.z/2])&& ...
                        rem(N(n,1),csize.x)==0
                    % if elements are exactly the correct spacing from one node
                        % to the next, then connect with cylinder.

                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                            if m>n
                                M=[M;n,m];

                            end
                        case sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_lin+misc.ebound && ...
                            sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_lin-misc.ebound && ...
                            rem(N(n,1),L)==0 && rem(N(n,2),L)==0 && rem(N(n,3),L)==0
                        % if elements are exactly the correct spacing from one node
                        % to the next, then connect with beam/rod.
                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                            if m>n
                                M=[M;n,m];

                            end

                    end
                end

            end
    end
    
    case('Octet')
        
    rod_length_obl=sqrt((csize.x/2)^2+(csize.y/2)^2); % Correct lenght of elements to find spacing
    

    for n=1:size(N,1)
            %sprintf('Current loop %d of %d',n,size(N,1))
            for m=1:size(N,1)
                if 1 % To remove duplicate connections
                    % If not checked for m>n (or vice versa) then the element
                    % could be created twice for combination (m,n) and (n,m)
                    % which would be a useless element.

                    switch 1
                        case any(sqrt(sum((N(n,:)-N(m,:)).^2))>(sqrt((csize.x/2)^2+(csize.y/2)^2)-misc.ebound) && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))<(sqrt((csize.x/2)^2+(csize.y/2)^2)+misc.ebound) ) && ...
                        all(abs(N(n,:)-N(m,:))==[csize.x/2,csize.y/2,0]) && ...
                        rem(N(n,3),csize.z)==0
                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                            if m>n
                                M=[M;n,m];

                            end

                        case any(sqrt(sum((N(n,:)-N(m,:)).^2))<(sqrt((csize.x/2)^2+(csize.z/2)^2)+misc.ebound) && ...
                            sqrt(sum((N(n,:)-N(m,:)).^2))>(sqrt((csize.x/2)^2+(csize.z/2)^2)-misc.ebound)) && ...
                            all(abs(N(n,:)-N(m,:))==[csize.x/2,0,csize.z/2]) && ...
                        rem(N(n,2),csize.y)==0

                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                            if m>n
                                M=[M;n,m];

                            end
                        case any(sqrt(sum((N(n,:)-N(m,:)).^2))<(sqrt((csize.z/2)^2+(csize.y/2)^2)+misc.ebound) && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))>(sqrt((csize.z/2)^2+(csize.y/2)^2)-misc.ebound)) && ...
                        all(abs(N(n,:)-N(m,:))==[0,csize.y/2,csize.z/2])&& ...
                        rem(N(n,1),csize.x)==0
                    % if elements are exactly the correct spacing from one node
                        % to the next, then connect with cylinder.

                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                            if m>n
                                M=[M;n,m];

                            end
                        case sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_obl+misc.ebound && ...
                            sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_obl-misc.ebound 
                                                        
                            if rem(N(n,1),L)==(L/2) || rem(N(n,2),L)==(L/2) || rem(N(n,3),L)==(L/2)
                                % if elements are exactly the correct spacing from one node
                                % to the next, then connect with beam/rod.
                                P(count,:)=[n,m];
                                count=count+1;
                                % Join nodes if spacing is exactly cell size
                                if m>n
                                    M=[M;n,m];

                                end
                            end

                    end
                end

            end
    end
    
    case('Octahedron')
    
    rod_length_obl=sqrt((csize.x/2)^2+(csize.y/2)^2+(csize.z/2)^2);    
    for n=1:size(N,1) %ciclo for per quanti sono i nodi
        %sprintf('Current loop %d of %d',n,size(N,1))
        for m=1:size(N,1) 
            if 1 % To remove duplicate connections
                % If not checked for m>n (or vice versa) then the element
                % could be created twice for combination (m,n) and (n,m)
                % which would be a useless element.
                 %if N(n,1)-fix(N(n,1))==0.5 || N(m,1)-fix(N(m,1))==0.5
                if sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_obl+misc.ebound && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_obl-misc.ebound
                    % if elements are exactly the correct spacing from one node
                    % to the next, then connect with beam/rod.
                    P(count,:)=[n,m];
                    count=count+1;
                    % Join nodes if spacing is exactly cell size
                    if m>n
                        M=[M;n,m];

                    end
                end

                if sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_lin+misc.ebound && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_lin-misc.ebound &&...
                    (rem(N(n,1),L)==L/2 || rem(N(n,2),L)==L/2 || rem(N(n,3),L)==L/2)
                    %((N(n,2)==N(m,2) && N(n,3)==N(m,3))|| (N(n,1)==N(m,1) && N(n,3)==N(m,3))) 
                    % if elements are exactly the correct spacing from one node
                    % to the next, then connect with beam/rod.
                    if (N(n,1)==N(m,1) && rem(N(n,3),L)==L/2) && N(n,2)~=N(m,2)
                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                        if m>n
                            M=[M;n,m];

                        end
                    end
                    if (N(n,2)==N(m,2) && rem(N(n,3),L)==L/2) && N(n,1)~=N(m,1)
                        P(count,:)=[n,m];
                        count=count+1;
                        % Join nodes if spacing is exactly cell size
                        if m>n
                            M=[M;n,m];

                        end
                    end    
                end
            end
        end
    end        
    
    case('CVC')
        
    rod_length_obl=sqrt((csize.x/2)^2+(csize.y/2)^2+(csize.z/2)^2); % Correct lenght of elements to find spacing
    for n=1:size(N,1) %ciclo for per quanti sono i nodi
        %sprintf('Current loop %d of %d',n,size(N,1))
        for m=1:size(N,1) 
            if 1 % To remove duplicate connections
                % If not checked for m>n (or vice versa) then the element
                % could be created twice for combination (m,n) and (n,m)
                % which would be a useless element.
                 %if N(n,1)-fix(N(n,1))==0.5 || N(m,1)-fix(N(m,1))==0.5
                if sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_obl+misc.ebound && ...
                        sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_obl-misc.ebound
                    % if elements are exactly the correct spacing from one node
                    % to the next, then connect with beam/rod.
                    P(count,:)=[n,m];
                    count=count+1;
                    % Join nodes if spacing is exactly cell size
                    if m>n
                        M=[M;n,m];

                    end
                end

%                     if sqrt(sum((N(n,:)-N(m,:)).^2))<rod_length_lin+misc.ebound && ...
%                             sqrt(sum((N(n,:)-N(m,:)).^2))>rod_length_lin-misc.ebound &&...
%                         rem(N(n,1),L)==0 && rem(N(n,2),L)==0 && rem(N(n,3),L)==0
%                         % if elements are exactly the correct spacing from one node
%                         % to the next, then connect with beam/rod.
%                         P(count,:)=[n,m];
%                         count=count+1;
%                         % Join nodes if spacing is exactly cell size
%                         if m>n
%                             M=[M;n,m];
% 
%                         end
%                     end
            end
        end
    end    
        
    
end


end